#!/usr/bin/perl
#
#
#
#
#
#

sub start_len {
   $start_size = $space;
}

sub end_len {
   my($label) = @_;

   print "#define $label ",$space-$start_size,"\n";
}
sub pack14 {

   my($label,@data) = @_;
   my($h,$l);
   my($mark) = ("         ");
   my($first) = (' ');
   my($len) = $#data+1;

   if ($label ne '') {$mark = ':';}
   printf ("%s%s dw", $label,$mark);

   if (($#data % 2) == 0) {
      push(@data, 0x00);
   }

   for ($i=0;$i<$#data;$i+=2) {
      if (($data[$i] & 0x80) || ($data[$i+1] & 0x80)) {
         print "Error, 8 bit data received\n";
      }
      $h = $data[$i]>>1;
      $l = $data[$i+1];
      if ($data[$i] & 0x01) {
         $l = $l + 0x80;	   
      }
      printf ("%s 0x%02X%02X",$first, $h, $l);
      $first = ',';
      if ((($i % 16) == 14) && (($i+2) < $#data)) {
         print "\n          dw ";
	 $first = ' ';
      }
   }
   print "\n";
   $space += $len;
}

sub strPack14 {

   my($data) = @_;
   my(@chars,$a);

   foreach $a (split(//,$data)) {
      push( @chars, ord($a));
   }
   pack14('',@chars);
}

sub pack14h {
   my($label,@data) = @_;

   for ($i=0;$i<$#data;$i++) {
      if (($i % 6) != 0) {
         $data[$i] = $data[$i]>>1;
      }
   }

   pack14($label, @data);
}

$space = 0;

print '
//**********************************************************************
//   Copyright (C) 2017 Dwayne Forsyth
//                                 
//   This program is free software; you can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published 0by the Free Software Foundation; either version 2
//   of the License, or (at your option) any later version.
// 
//   This program is distributed in the hope that it will 0be useful,
//   0but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the
// 
//      Free Software Foundation, Inc.
//      51 Franklin Street, Fifth Floor
//      Boston, MA  02110-1301, USA.
//
//**********************************************************************
// This file is Generated by packed_patterns.pl
//**********************************************************************
#include "system_config.h"
#include "ascii_table.h"
#include "stdint.h"
#include "system_config.h"

#asm
PSECT myAsmConst, class=CODE, delta=2,space=0,abs,ovrld
org 0x1A00
';

start_len();
pack14("_pattern0",
     0x07,0x20,
#--- Frame 1,
     0b00000000, #  y=000 x=000,  a=0, set all LEDs off
     0b00001111, #  y=000 xa=1111, eof
     0b00000011, #  y=000 xa=0011, y=000, shift down, fill 1
     0b00001111, #  y=000 xa=1111, eof
     0b00000010, #  y=000 xa=0010, y=000, shift down
     0b00001111, #  y=000 xa=1111, eof
     0b00000010, #  y=000 xa=0010, y=000, shift down
     0b00001111, #  y=000 xa=1111, eof
     0b00000010, #  y=000 xa=0010, y=000, shift down
     0b00001111, #  y=000 xa=1111, eof
     0b00000010, #  y=000 xa=0010, y=000, shift down
     0b00001111, #  y=000 xa=1111, eof
     0b00000010, #  y=000 xa=0010, y=000, shift down
     0b00001111, #  y=000 xa=1111, eof
     0b00000010, #  y=000 xa=0010, y=000, shift down
     0b00001111, #  y=000 xa=1111, eof
     0b00000010, #  y=000 xa=0010, y=000, shift down
     0b00001111, #  y=000 xa=1111, eof
     0b00000111, #  y=000 xa=0111, y=000, shift right, fill 1
     0b00001111, #  y=000 xa=1111, eof
     0b00000110, #  y=000 xa=0110, y=000, shift right
     0b00001111, #  y=000 xa=1111, eof
     0b00000110, #  y=000 xa=0110, y=000, shift right
     0b00001111, #  y=000 xa=1111, eof
     0b00000110, #  y=000 xa=0110, y=000, shift right
     0b00001111, #  y=000 xa=1111, eof
     0b00000110, #  y=000 xa=0110, y=000, shift right
     0b00001111, #  y=000 xa=1111, eof
     0b00000110, #  y=000 xa=0110, y=000, shift right
     0b00001111, #  y=000 xa=1111, eof
     0b00000110, #  y=000 xa=0110, y=000, shift right
     0b00001111, #  y=000 xa=1111, eof
     0b00000110, #  y=000 xa=0110, y=000, shift right
     0b00001111, #  y=000 xa=1111, eof
     0b00000110, #  y=000 xa=0110, y=000, shift right
     0b00001111  #  y=000 xa=1111, eof
);
end_len("PATTERN0_SIZE");

print '
_pattern0e
//**********************************************************************
// Fader test
//**********************************************************************
';
start_len();
pack14("_pattern1",
     0x06,0x17,
#//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000011,
     0b00000111,
     0b00001111,
     0b00011111,
     0b00111110,
     0b01111100,
     0b01111000,
     0b01110000,
     0b01100000,
     0b01000000,
);
end_len("PATTERN1_SIZE");
print '
_pattern1e
#ifndef MEMLIGHT
//**********************************************************************
// Pong
//**********************************************************************
';

start_len();
pack14("_pattern2",
     0x07,0x70,
#//1
     0b00000000, #// x=000, y=000, a=0, set all LEDs off
     0b01111111, #// 7,7 = 1  paddle
     0b01101111, #// 7,6 = 1
     0b01011111, #// 7,5 = 1
     0b01011010, #// 5,5 = 0 remove old ball
     0b01101101, #// 6,6 = 1   ball
     0b01010001, #// 0,5 = 1   paddle
     0b01000001, #// 0,4 = 1
     0b00110001, #// 0,3 = 1
     0b00001111, #  y=000 xa=1111, eof
#//2
     0b01101100, #// 6,6 = 0 remove old ball
     0b01111011, #// 5,7 = 1  new ball
     0b00001111, #  y=000 xa=1111, eof
#//3
     0b01111010, #// 5,7 = 0 remove old ball
     0b01101001, #// 4,6 = 1  new ball
     0b00001111, #  y=000 xa=1111, eof
#//4
     0b01010000, #// 0,5 = 0 left paddle down
     0b00100001, #// 0,2 = 1
     0b01101000, #// 4,6 = 0 remove old ball
     0b01010111, #// 3,5 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//5
     0b01010110, #// 3,5 = 0 remove old ball
     0b01000101, #// 2,4 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//6
     0b01000100, #// 2,4 = 0 remove old ball
     0b00110011, #// 1,3 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//7
     0b00110010, #// 1,3 = 0 remove old ball
     0b00100101, #// 2,2 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//8
     0b00100100, #// 2,2 = 0 remove old ball
     0b00010111, #// 3,1 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//9
     0b00010110, #// 3,1 = 0 remove old ball
     0b00101001, #// 4,2 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//10
     0b01111110, #// 7,7 = 0 right paddle down
     0b01001111, #// 7,4 = 1
     0b00101000, #// 4,2 = 0 remove old ball
     0b00111011, #// 5,3 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//11
     0b01101110, #// 7,6 = 0 right paddle down
     0b00111111, #// 7,3 = 1
     0b00111010, #// 5,3 = 0 remove old ball
     0b01001101, #// 6,4 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//12
     0b01001100, #// 6,4 = 0 remove old ball
     0b01011011, #// 5,5 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//13
     0b01011010, #// 5,5 = 0 remove old ball
     0b01101001, #// 4,6 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//14
     0b01010001, #// 0,5 = 1 left paddle up
     0b00100000, #// 0,2 = 0
     0b01101000, #// 4,6 = 0 remove old ball
     0b01110111, #// 3,7 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//15
     0b01100001, #// 0,6 = 1 left paddle up
     0b00110000, #// 0,3 = 0
     0b01110110, #// 3,7 = 0 remove old ball
     0b01100101, #// 2,6 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//16
     0b01100100, #// 2,6 = 0 remove old ball
     0b01010011, #// 1,5 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//17
     0b01010010, #// 1,5 = 0 remove old ball
     0b01000101, #// 2,4 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//18
     0b01000100, #// 2,4 = 0 remove old ball
     0b00110111, #// 3,3 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//19
     0b01011110, #// 7,5 = 0 right paddle down
     0b00101111, #// 7,2 = 1

     0b00110110, #// 3,3 = 0 remove old ball
     0b00101001, #// 4,2 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//20
     0b01001110, #// 7,4 = 0 right paddle down
     0b00011111, #// 7,1 = 1

     0b00101000, #// 4,2 = 0 remove old ball
     0b00011011, #// 5,1 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//21
     0b00011010, #// 5,1 = 0 remove old ball
     0b00101101, #// 6,2 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//22
     0b00101100, #// 6,2 = 0 remove old ball
     0b00111011, #// 5,3 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//23
     0b00111010, #// 5,3 = 0 remove old ball
     0b01001001, #// 4,4 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//24
     0b01110001, #// 0,7 = 1 left paddle up
     0b01000000, #// 0,4 = 0

     0b01001000, #// 4,4 = 0 remove old ball
     0b01010111, #// 3,5 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//25
     0b01010110, #// 3,5 = 0 remove old ball
     0b01100101, #// 2,6 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//26
     0b01100100, #// 2,6 = 0 remove old ball
     0b01110011, #// 1,7 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//27
     0b01110010, #// 1,7 = 0 remove old ball
     0b01100101, #// 2,6 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//28
     0b01000001, #// 0,4 = 1 left paddle Down
     0b01110000, #// 0,7 = 0

     0b01100100, #// 2,6 = 0 remove old ball
     0b01010111, #// 3,5 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//29
     0b01010110, #// 3,5 = 0 remove old ball
     0b01001001, #// 4,4 = 1, eof  new bal
     0b00001111, #  y=000 xa=1111, eof
#//30
     0b01001000, #// 4,4 = 0 remove old ball
     0b00111011, #// 5,3 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//31
     0b00111010, #// 5,3 = 0 remove old ball
     0b00101101, #// 6,2 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//32
     0b00101100, #// 6,2 = 0 remove old ball
     0b00011011, #// 5,1 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//33
     0b00011010, #// 5,1 = 0 remove old ball
     0b00101001, #// 4,2 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//34
     0b00101000, #// 4,2 = 0 remove old ball
     0b00110111, #// 3,3 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//35
     0b00110110, #// 3,3 = 0 remove old ball
     0b01000101, #// 2,4 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//36
     0b01000100, #// 2,4 = 0 remove old ball
     0b01010011, #// 1,5 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//37
     0b01010010, #// 1,5 = 0 remove old ball
     0b01100101, #// 2,6 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//38
     0b00011110, #// 7,1 = 0 right paddle up
     0b01001111, #// 7,4 = 1

     0b01100100, #// 2,6 = 0 remove old ball
     0b01110111, #// 3,7 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//39
     0b00101110, #// 7,2 = 0 right paddle up
     0b01011111, #// 7,5 = 1

     0b01110110, #// 3,7 = 0 remove old ball
     0b01101001, #// 4,6 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//40
     0b01101000, #// 4,6 = 0 remove old ball
     0b01011011, #// 5,5 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//41
     0b01011010, #// 5,5 = 0 remove old ball
     0b01001101, #// 6,4 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//42
     0b01001100, #// 6,4 = 0 remove old ball
     0b00111011, #// 5,3 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//43
     0b00111010, #// 5,3 = 0 remove old ball
     0b00101001, #// 4,2 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//44
     0b00101000, #// 4,2 = 0 remove old ball
     0b00010111, #// 3,1 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//45
     0b00110001, #// 0,3 = 1 left paddle Down
     0b01100000, #// 0,6 = 0

     0b00010110, #// 3,1 = 0 remove old ball
     0b00100101, #// 2,2 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//46
     0b00100001, #// 0,2 = 1 left paddle Down
     0b01010000, #// 0,5 = 0

     0b00100100, #// 2,2 = 0 remove old ball
     0b00110011, #// 1,3 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//47
     0b00110010, #// 1,3 = 0 remove old ball
     0b01000101, #// 2,4 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//48
     0b01000100, #// 2,4 = 0 remove old ball
     0b01010111, #// 3,5 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//49
     0b00111110, #// 7,3 = 0 right paddle up
     0b01101111, #// 7,6 = 1

     0b01010110, #// 3,5 = 0 remove old ball
     0b01101001, #// 4,6 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//50
     0b01001110, #// 7,4 = 0 right paddle up
     0b01111111, #// 7,7 = 1

     0b01101000, #// 4,6 = 0 remove old ball
     0b01111011, #// 5,7 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//51
     0b01111010, #// 5,7 = 0 remove old ball
     0b01101101, #// 6,6 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//52
     0b01101100, #// 6,6 = 0 remove old ball
     0b01011011, #// 5,5 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//53
     0b01011010, #// 5,5 = 0 remove old ball
     0b01001001, #// 4,4 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//54
     0b00010001, #// 0,1 = 1 left paddle Down
     0b01000000, #// 0,4 = 0

     0b01001000, #// 4,4 = 0 remove old ball
     0b00110111, #// 3,3 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//55

     0b00110110, #// 3,3 = 0 remove old ball
     0b00100101, #// 2,2 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//56
     0b00100100, #// 2,2 = 0 remove old ball
     0b00010011, #// 1,1 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//57
     0b00010010, #// 1,1 = 0 remove old ball
     0b00100101, #// 2,2 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//58
     0b00100100, #// 2,2 = 0 remove old ball
     0b00110111, #// 3,3 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//59
     0b00110110, #// 3,3 = 0 remove old ball
     0b01001001, #// 4,4 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
#//60
     0b01001000, #// 4,4 = 0 remove old ball
     0b01011011, #// 5,5 = 1, eof  new ball
     0b01011011, #// 5,5 = 1, eof  new ball
     0b00001111, #  y=000 xa=1111, eof
);
end_len("PATTERN2_SIZE");

print '
_pattern2e
//**********************************************************************
// Fader test
//**********************************************************************
';
start_len();
pack14("_pattern3",
     0x06,0x20,
#//--- Frame 1,
     0b00000001,
     0b00000011,
     0b00000111,
     0b00001111,
     0b00011111,
     0b00111111,
     0b01111111,
     0b00111111,
     0b00011111,
     0b00001111,
     0b00000111,
     0b00000011,
     0b00000001,
     0b00000000,

);
end_len("PATTERN3_SIZE");

print '
_pattern3e
//**********************************************************************
// half sync fading
//**********************************************************************
';
start_len();
pack14("_pattern4",
     0x08,0x06,
#//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000111,
#//--- Frame 1,
     0b01000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000111,
#//--- Frame 1,
     0b00100000,
     0b01000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000111,
#  //--- Frame 1,
     0b00010000,
     0b00100000,
     0b01000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000111,
#//--- Frame 1,
     0b00001000,
     0b00010000,
     0b00100000,
     0b01000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000111,
#//--- Frame 1,
     0b00000100,
     0b00001000,
     0b00010000,
     0b00100000,
     0b01000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000111,
#//--- Frame 1,
     0b00000010,
     0b00000100,
     0b00001000,
     0b00010000,
     0b00100000,
     0b01000000,
     0b00000000,
     0b00000000,
     0b00000111,
#//--- Frame 1,
     0b00000001,
     0b00000010,
     0b00000100,
     0b00001000,
     0b00010000,
     0b00100000,
     0b01000000,
     0b00000000,
     0b00000111,
#//--- Frame 1,
     0b00000000,
     0b00000001,
     0b00000010,
     0b00000100,
     0b00001000,
     0b00010000,
     0b00100000,
     0b01000000,
     0b00000111,
#//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000010,
     0b00000100,
     0b00001000,
     0b00010000,
     0b00100000,
     0b00000111,
#//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000010,
     0b00000100,
     0b00001000,
     0b00010000,
     0b00000111,
#//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000010,
     0b00000100,
     0b00001000,
     0b00000111,
#//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000010,
     0b00000100,
     0b00000111,
#//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000010,
     0b00000111,
#//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000111,
#//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000111
);
end_len("PATTERN4_SIZE");
print '
_pattern4e
//**********************************************************************
// fast flash
//**********************************************************************
';

start_len();
pack14("_pattern5",
     0x03, 0x04
     );
strPack14("  I went to Build-a-Blinkie built this cool blinkie ");
end_len("PATTERN5_SIZE");

print '
_pattern5e
//**********************************************************************
//  so many blinkies, so little time
//**********************************************************************
';
start_len();
pack14("_pattern6",
     0x03, 0x03
     );
strPack14("  so many blinkies, so little time. ");
end_len("PATTERN6_SIZE");
print '
_pattern6e
//**********************************************************************
//  www.2dkits.com
//**********************************************************************
';
start_len();
pack14("_pattern7",
     0x03, 0x05
     );
strPack14("  www.2dkits.com");
end_len("PATTERN7_SIZE");
print '
_pattern7e
//**********************************************************************
//  www.Build-a-Blinkie.org
//**********************************************************************
';
start_len();
pack14("_pattern8",
     0x03, 0x04
     );
strPack14("  www.Build-a-Blinkie.org");
end_len("PATTERN8_SIZE");
print '
_pattern8e
//**********************************************************************
// random fader
//**********************************************************************
';
start_len();
pack14("_pattern9", 
     0x09,0x10,
     0b00000111
);
end_len("PATTERN9_SIZE");

print '
_pattern9e
//**********************************************************************
// random fader
//**********************************************************************
';
start_len();
pack14("_pattern10", 
     0x08,0x02,
#//--- Frame 1,
     0b01111000,
     0b01110000,
     0b01100000,
     0b01000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000011,
#//--- Frame 1,
     0b01111100,
     0b01111000,
     0b01110000,
     0b01100000,
     0b01000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000011,
#//--- Frame 1,
     0b00111110,
     0b01111100,
     0b01111000,
     0b01110000,
     0b01100000,
     0b01000000,
     0b00000000,
     0b00000000,
     0b00000011,
#//--- Frame 1,
     0b00011111,
     0b00111110,
     0b01111100,
     0b01111000,
     0b01110000,
     0b01100000,
     0b01000000,
     0b00000000,
     0b00000011,
#//--- Frame 1,
     0b00001111,
     0b00011111,
     0b00111110,
     0b01111100,
     0b01111000,
     0b01110000,
     0b01100000,
     0b01000000,
     0b00000011,
#//--- Frame 1,
     0b00000111,
     0b00001111,
     0b00011111,
     0b00111110,
     0b01111100,
     0b01111000,
     0b01110000,
     0b01100000,
     0b00000011,
#//--- Frame 1,
     0b00000011,
     0b00000111,
     0b00001111,
     0b00011111,
     0b00111110,
     0b01111100,
     0b01111000,
     0b01110000,
     0b00000011,
#//--- Frame 1,
     0b00000001,
     0b00000011,
     0b00000111,
     0b00001111,
     0b00011111,
     0b00111110,
     0b01111100,
     0b01111000,
     0b00000011,
#//--- Frame 1,
     0b00000000,
     0b00000001,
     0b00000011,
     0b00000111,
     0b00001111,
     0b00011111,
     0b00111110,
     0b01111100,
     0b00000011,
#//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000011,
     0b00000111,
     0b00001111,
     0b00011111,
     0b00111110,
     0b00000011,
#//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000011,
     0b00000111,
     0b00001111,
     0b00011111,
     0b00000011,
#//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000011,
     0b00000111,
     0b00001111,
     0b00000011,
#//--- Frame 1,
     0b01000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000011,
     0b00000111,
     0b00000011,
#//--- Frame 1,
     0b01100000,
     0b01000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000011,
     0b00000011,
#//--- Frame 1,
     0b01110000,
     0b01100000,
     0b01000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000011,
);
end_len("PATTERN10_SIZE");
print '
_pattern10e
#endif
//**********************************************************************
// Char tables
//**********************************************************************
';

pack14h("_chardata", 
   0x01,  0x00, 0x00, 0x00, 0x00, 0x00, #/ 0x20 space
   0x01,  0xF2, 0x00, 0x00, 0x00, 0x00, #/ 0x21 !
   0x03,  0xE0, 0x00, 0xE0, 0x00, 0x00, #/ 0x22 "
   0x05,  0x28, 0xFE, 0x28, 0xFE, 0x28, #/ 0x23 #
   0x05,  0x24, 0x54, 0xFE, 0x54, 0x48, #/ 0x24 $
   0x05,  0xC4, 0xC8, 0x10, 0x26, 0x46, #/ 0x25%
   0x05,  0x6C, 0x92, 0xAA, 0x84, 0x0A, #/ 0x26 &
   0x02,  0xA0, 0xC0, 0x00, 0x00, 0x00, #/ 0x27 
   0x03,  0x38, 0x44, 0x82, 0x00, 0x00, #/ 0x28 (
   0x03,  0x82, 0x44, 0x38, 0x00, 0x00, #/ 0x29 )
   0x05,  0x28, 0x10, 0x7C, 0x10, 0x28, #/ 0x2A *
   0x05,  0x10, 0x10, 0x7C, 0x10, 0x10, #/ 0x2B +
   0x02,  0x05, 0x06, 0x00, 0x00, 0x00, #/ 0x2C ,
   0x04,  0x10, 0x10, 0x10, 0x10, 0x00, #/ 0x2D -
   0x02,  0x06, 0x06, 0x00, 0x00, 0x00, #/ 0x2E .
   0x05,  0x04, 0x08, 0x10, 0x20, 0x40, #/ 0x2F /
   0x04,  0x7C, 0x82, 0x82, 0x7C, 0x00, #/ 0x30 0
   0x03,  0x42, 0xFE, 0x02, 0x00, 0x00, #/ 0x31 1
   0x04,  0x46, 0x8A, 0x92, 0x62, 0x00, #/ 0x32 2
   0x04,  0x44, 0x82, 0x92, 0x6C, 0x00, #/ 0x33 3
   0x05,  0x18, 0x28, 0x48, 0xFE, 0x08, #/ 0x34 4
   0x04,  0xE4, 0xA2, 0xA2, 0x9C, 0x00, #/ 0x35 5
   0x04,  0x3C, 0x52, 0x92, 0x0C, 0x00, #/ 0x36 6
   0x04,  0x80, 0x8E, 0x90, 0xE0, 0x00, #/ 0x37 7
   0x04,  0x6C, 0x92, 0x92, 0x6C, 0x00, #/ 0x38 8
   0x04,  0x60, 0x92, 0x92, 0x7C, 0x00, #/ 0x39 9
   0x02,  0x36, 0x36, 0x00, 0x00, 0x00, #/ 0x3A :
   0x02,  0x35, 0x36, 0x00, 0x00, 0x00, #/ 0x3B ;
   0x04,  0x10, 0x28, 0x44, 0x82, 0x00, #/ 0x3C <
   0x05,  0x28, 0x28, 0x28, 0x28, 0x28, #/ 0x3D =
   0x04,  0x82, 0x44, 0x28, 0x10, 0x00, #/ 0x3E >
   0x05,  0x40, 0x80, 0x8A, 0x90, 0x60, #/ 0x3F ?
   0x05,  0x4C, 0x92, 0x9E, 0x82, 0x7C, #/ 0x40 @
   0x05,  0x3E, 0x48, 0x88, 0x48, 0x3E, #/ 0x41 A
   0x05,  0xFE, 0x92, 0x92, 0x92, 0x6C, #/ 0x42 B
   0x05,  0x7C, 0x82, 0x82, 0x82, 0x44, #/ 0x43 C
   0x05,  0xFE, 0x82, 0x82, 0x82, 0x7C, #/ 0x44 D
   0x05,  0xFE, 0x92, 0x92, 0x92, 0x92, #/ 0x45 E
   0x05,  0xFE, 0x90, 0x90, 0x90, 0x90, #/ 0x46 F
   0x05,  0x7C, 0x82, 0x92, 0x92, 0x5C, #/ 0x47 G
   0x05,  0xFE, 0x10, 0x10, 0x10, 0xFE, #/ 0x48 H
   0x03,  0x82, 0xFE, 0x82, 0x00, 0x00, #/ 0x49 I
   0x04,  0x04, 0x02, 0x02, 0xFC, 0x00, #/ 0x4A J
   0x05,  0xFE, 0x10, 0x28, 0x44, 0x82, #/ 0x4B K
   0x05,  0xFE, 0x02, 0x02, 0x02, 0x02, #/ 0x4C L
   0x05,  0xFE, 0x40, 0x30, 0x40, 0xFE, #/ 0x4D M
   0x05,  0xFE, 0x40, 0x20, 0x10, 0xFE, #/ 0x4E N
   0x05,  0x7C, 0x82, 0x82, 0x82, 0x7C, #/ 0x4F O
   0x05,  0xFE, 0x90, 0x90, 0x90, 0x60, #/ 0x50 P
   0x05,  0x7C, 0x82, 0x8A, 0x84, 0x7A, #/ 0x51 Q
   0x05,  0xFE, 0x90, 0x98, 0x94, 0x62, #/ 0x52 R
   0x05,  0x64, 0x92, 0x92, 0x92, 0x4C, #/ 0x53 S
   0x05,  0x80, 0x80, 0xFE, 0x80, 0x80, #/ 0x54 T
   0x05,  0xFC, 0x02, 0x02, 0x02, 0xFC, #/ 0x55 U
   0x05,  0xF8, 0x04, 0x02, 0x04, 0xF8, #/ 0x56 V
   0x05,  0xFC, 0x02, 0x1C, 0x02, 0xFC, #/ 0x57 W
   0x05,  0xC6, 0x28, 0x10, 0x28, 0xC6, #/ 0x58 X
   0x05,  0xE0, 0x10, 0x0E, 0x10, 0xE0, #/ 0x59 Y
   0x05,  0x86, 0x8A, 0x92, 0xA2, 0xC2, #/ 0x5A Z
   0x03,  0xFE, 0x82, 0x82, 0x00, 0x00, #/ 0x5B [
   0x05,  0x40, 0x20, 0x10, 0x08, 0x04, #/ 0x5C
   0x03,  0x82, 0x82, 0xFE, 0x00, 0x00, #/ 0x5D ]
   0x05,  0x20, 0x40, 0x80, 0x40, 0x20, #/ 0x5E ^
   0x05,  0x01, 0x01, 0x01, 0x01, 0x01, #/ 0x5F _
   0x02,  0xC0, 0xA0, 0x00, 0x00, 0x00, #/ 0x60 `
   0x04,  0x04, 0x2A, 0x2A, 0x1E, 0x00, #/ 0x61 a
   0x04,  0xFE, 0x22, 0x22, 0x1C, 0x00, #/ 0x62 b
   0x04,  0x1C, 0x22, 0x22, 0x22, 0x00, #/ 0x63 c
   0x04,  0x1C, 0x22, 0x22, 0xFE, 0x00, #/ 0x64 d
   0x04,  0x1C, 0x2A, 0x2A, 0x18, 0x00, #/ 0x65 e
   0x04,  0x10, 0x7E, 0x90, 0x40, 0x00, #/ 0x66 f
   0x04,  0x18, 0x25, 0x25, 0x3E, 0x00, #/ 0x67 g
   0x04,  0xFE, 0x10, 0x20, 0x1E, 0x00, #/ 0x68 h
   0x03,  0x22, 0xBE, 0x02, 0x00, 0x00, #/ 0x69 i
   0x04,  0x02, 0x01, 0x21, 0xBE, 0x00, #/ 0x6A j
   0x04,  0xFE, 0x08, 0x14, 0x22, 0x00, #/ 0x6B k
   0x03,  0x82, 0xFE, 0x02, 0x00, 0x00, #/ 0x6C l
   0x05,  0x1E, 0x20, 0x18, 0x20, 0x1E, #/ 0x6D m
   0x04,  0x3E, 0x10, 0x20, 0x1E, 0x00, #/ 0x6E n
   0x04,  0x1C, 0x22, 0x22, 0x1C, 0x00, #/ 0x6F o
   0x04,  0x3F, 0x24, 0x24, 0x18, 0x00, #/ 0x70 p
   0x04,  0x18, 0x24, 0x24, 0x3F, 0x00, #/ 0x71 q
   0x04,  0x3E, 0x10, 0x20, 0x20, 0x00, #/ 0x72 r
   0x04,  0x10, 0x2A, 0x2A, 0x04, 0x00, #/ 0x73 s
   0x03,  0x20, 0x7E, 0x20, 0x00, 0x00, #/ 0x74 t
   0x04,  0x3C, 0x02, 0x02, 0x3C, 0x00, #/ 0x75 u
   0x05,  0x38, 0x04, 0x02, 0x04, 0x38, #/ 0x76 v
   0x05,  0x3C, 0x02, 0x0C, 0x02, 0x3C, #/ 0x77 w
   0x05,  0x22, 0x14, 0x08, 0x14, 0x22, #/ 0x78 x
   0x05,  0x38, 0x05, 0x05, 0x3E, 0x00, #/ 0x79 y
   0x04,  0x26, 0x2A, 0x32, 0x00, 0x00, #/ 0x7A z
   0x03,  0x10, 0x6C, 0x82, 0x00, 0x00, #/ 0x7B {
   0x01,  0xFF, 0x00, 0x00, 0x00, 0x00, #/ 0x7C |
   0x03,  0x82, 0x6C, 0x10, 0x00, 0x00, #/ 0x7D }
);

print '_pat1
';
strPack14("======\r\n");
print '_pat2
';
strPack14("unknown command\r\n");
print '_pat3
';
start_len();
strPack14("2DKits.com\r\n7x8 Matrix\r\nV1.0\r\n");
end_len("MSG3_LEN");
print '_pat4
';
start_len();
strPack14("Commands:\r\n H : Help\r\n P+ : Next Pattern\r\n P- : Previous Pattern\r\n");
end_len("MSG4_LEN");
print '_pat5
';
start_len();
strPack14(" R0 : Stop Pattern\r\n R1 : resume Pattern\r\n");
end_len("MSG5_LEN");
print '_pat6
';
start_len();
strPack14(" D0 : Demo mode off\r\n D1 : Demo mode on\r\n");
end_len("MSG6_LEN");

print '_pat7
';
start_len();
strPack14(" C{[x][y][v]}+ : Set LEDs\r\n");
end_len("MSG7_LEN");
print '_pat8
';
start_len();
strPack14(" M[msg] : ascii message to display\r\n");
end_len("MSG8_LEN");
print '_pat9
';
start_len();
strPack14(" U[number] : read and set User id\r\n");
end_len("MSG9_LEN");

print '
//
// The flash memory is done in 32 words of 14 bits.
//
//  1FA0-1FBF [pattern type][speed]1st 30 char of user message
//  1FC0-1FDf 2nd 32 char of user message
//  1E00-1FFF user settings
//
PSECT myAsmStore, class=CODE, delta=2,space=0,abs,ovrld
org 0x1FA0
_msg1
';
#          0                   1                   2                   3     
strPack14("0011223344556677889900112233445566778899001122334455667788990011");
print '_msg2
';
#          0                   1                   2                   3     
strPack14("0011223344556677889900112233445566778899001122334455667788990011");
print '_fDemoMode
_setting
          dw   0x1801
_fUserMsgSize
          dw   0x0000
_fUserId
          dw   0x0000
#endasm

patterns_t patterns[USER_DEFINED_PATTERN] = {
    { (uint8_t *) &pattern0, 
         PATTERN0_SIZE,
         15},
    { (uint8_t *) &pattern1, 
         PATTERN1_SIZE,
         30},
    { (uint8_t *) &pattern2, 
         PATTERN2_SIZE,
         6},
    { (uint8_t *) &pattern3, 
         PATTERN3_SIZE,
         25},
    { (uint8_t *) &pattern4, 
         PATTERN4_SIZE,
         15},
    { (uint8_t *) &pattern5, 
         PATTERN5_SIZE,
         5},
    { (uint8_t *) &pattern6, 
         PATTERN6_SIZE,
         4},
    { (uint8_t *) &pattern7, 
         PATTERN7_SIZE,
         4},
    { (uint8_t *) &pattern8, 
         PATTERN8_SIZE,
         5},
    { (uint8_t *) &pattern9, 
         PATTERN9_SIZE,
         80},
    { (uint8_t *) &pattern10, 
         PATTERN10_SIZE,
         90},
};
';

#printf("used = %X\n",$space);
#printf("start = %X\n",0x2000 - $space);
