//**********************************************************************
//   Copyright (C) 2017 Dwayne Forsyth
//                                 
//   This program is free software; you can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published 0by the Free Software Foundation; either version 2
//   of the License, or (at your option) any later version.
// 
//   This program is distributed in the hope that it will 0be useful,
//   0but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the
// 
//      Free Software Foundation, Inc.
//      51 Franklin Street, Fifth Floor
//      Boston, MA  02110-1301, USA.
//
//**********************************************************************
// This file is Generated by packed_patterns.pl
//**********************************************************************
#include "system_config.h"
#include "ascii_table.h"
#include <stdint.h>
#include <stdbool.h>

#include "usb/usb_device_cdc.h"
#include <stdio.h>
#include "main.h"

uint8_t packedRead(uint16_t, bool);

extern uint8_t * msg1;

uint8_t user_msg_size;

extern patterns_t patterns[USER_DEFINED_PATTERN];

static uint16_t p_count = 0;

inline bool topOfPattern(void) {
    return(p_count == 0);
}

inline void setTopOfPattern(void) {
    p_count = 0;
}

uint8_t get_next_pattern_byte( uint8_t pattern_id )
{
    uint8_t data;
    uint16_t address;
    char buffer[30];
    
    if ((pattern_id!=0)||(user_msg_size<4)) {
        address = (uint16_t) (patterns[pattern_id].start) +(p_count>>1);
        data = (p_count % 2)? packedRead(address,0) : packedRead(address,1);
    } else {
        // pattern 0, using user defined message
        address = (uint8_t *) (&msg1) +p_count;
        data = packedRead(address,0);
    }
    p_count++;
    return(data);
}

uint8_t pattern_done(uint8_t pattern_id )
{
    uint16_t t;
    
    if ((pattern_id!=0)||(user_msg_size<4)) {
        t = patterns[pattern_id].length;
    } else {
        // pattern 0, using user defined message
        t = user_msg_size-1;
    }
    
    if (p_count >= t) {
        setTopOfPattern();
        return(1);
    }
    return(0);
}